--Create a set of geometric objects	in Lua as tables
square1 = {side = 5}
square2 = {side = 7}
rectangle1 = {width = 4, height = 6}
rectangle2 = {width = 8, height = 2}
circle1 = {radius = 3}
triangle1 = {side1 = 5, side2 = 4, side3 = 3}


--Build one function to calculate the perimeter of a geometric figure...
function perimeter(obj) 
	if obj.side then
		--case square
		return 4*obj.side
	elseif obj.width~=nil then
		--case rectangle
		return 2*(obj.width+obj.height)
	elseif obj.radius then
		--case circle
		return 2*math.pi*obj.radius
	elseif obj.side1 then
		--case triangle
		return obj.side1+obj.side2+obj.side3
	else 
		--none of them
		print("Function perimeter(obj) needs valid geometric-object as attribute!")
	end
end
-- ...and another to compute its area
function area(obj) 
	if obj.side~=nil then
		--case square
		return obj.side^2
	elseif obj.width then
		--case rectangle
		return obj.width*obj.height
	elseif obj.radius then
		--case circle
		return math.pi*(obj.radius^2)
	elseif obj.side1 then 
		--case triangle
		s = (obj.side1+obj.side2+obj.side3)/2 --calculate semiperimeter
		return math.sqrt(s*(s-obj.side1)*(s-obj.side2)*(s-obj.side3)) --Heron's formula
	else 
		--none of them
		print("Function area(obj) needs valid geometric-object as attribute!")
	end
end


print( perimeter( square1 ), 	area( square1 ) ) 
print( perimeter( rectangle1 ), area( rectangle1 ) ) 
print( perimeter( circle1 ), 	area( circle1 ) )
print( perimeter( triangle1 ), 	area( triangle1 ) )  